/* ========================================================================= *
 * separate
 *
 * Separate a text input into words using a dynamic programming approach
 * ========================================================================= */

#ifndef _SEPARATE_H_
#define _SEPARATE_H_

#include "hashtable.h"

/* ------------------------------------------------------------------------- *
 * Segments the character sequence $input$ into words.
 *
 * PARAMETERS
 * input            Input character sequence.
 * log_frequencies  A hash table which maps strings to log frequencies
 *
 * RETURN
 * words            The sequence of words. Words must be separated by the
 *                  space character. Must be freed by the caller.
 * NULL             If an error has occured. The function does not produces any
 *                  error message.
 * ------------------------------------------------------------------------- */
char* separate(const char* input, const hashtable *log_frequencies);

#endif /* _SEPARATE_H_ */
